package DBAgent;

import alice.tucson.api.*;
import alice.logictuple.*;

public class AccessAgent extends Agent {
	
	/**
	 * Centro tuple di sincronizzazione
	 */
	TupleCentreId Sinc;
	
	/**
	 * Ottimizzatore locale
	 */
	IQueryOptAgent Opt;
	
	/**
	 * identificativo del terminale corrente
	 */
	int Tid;
	
	/**
	 * Costruttore
	 * @param S Centro tuple di sincronizzazione
	 */
	public AccessAgent(AgentId name, TupleCentreId S, IQueryOptAgent O, int T) throws TucsonException {
		super(name);
		Sinc = S;
		Opt = O;
		Tid = T;
	}
	
	/**
	 * corpo del thread
	 */
	public void body(){
		try{
			while(true){
				LogicTuple LT = new LogicTuple("addT", new Var("Host_name"), new Value(Tid));
				LogicTuple LTR = in(Sinc,LT);	
				TupleArgument Host = LTR.getArg(0);
				String Host_name = Host.toString();
				TupleCentreId coda = new TupleCentreId("coda @ " + Host_name);
				TupleCentreId query = new TupleCentreId("query @ " + Host_name);
				Opt.addTerminal(coda,query,Host_name);
				System.out.println("Terminal connected: " + Host_name);
			}
		}catch(Exception e){
			System.out.println("Errore body AA");
		}
	}
	
}
