package DBAgent;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import alice.logictuple.*;
import alice.tucson.api.*;

public class Controller extends Agent{
	
	TupleCentreId tcQuery;
	
	IDataBase dataBase;
	
	/**
	 * Costruttore
	 */
	public Controller (AgentId name, TupleCentreId query, IDataBase DB) throws TucsonException{
		super(name);
		tcQuery = query;
		dataBase = DB;
	}
	
	/**
	 * Corpo del thread
	 */
	public void body(){
		try{
			while(true){
				LogicTuple req = new LogicTuple("query", new Var("QueryS"));
				LogicTuple resp = in(tcQuery,req);	
				TupleArgument Query = resp.getArg(0);
				String Q = Query.toString();
				String Q_E = Q.substring(2,Q.length()-2);
				
				Object Response = dataBase.resolveQuery(this.convertToObject(Q_E));
				
				String ResponseS = this.convertToString(Response);
				req = new LogicTuple("result", new Value(ResponseS));
				out(tcQuery,req);				
				System.out.println("Risposta inviata");
			}
		}catch(Exception e){}
	}
	
	/**
	 * Metodo che crea un oggetto dalla sua serializzazione
	 * @param queryS Oggetto serializzato
	 * @return Oggetto
	 */
	public Object convertToObject(String queryS){
		Object o = null;
		try{		
			byte[] buffer = queryS.getBytes();
			ByteArrayInputStream BAIS = new ByteArrayInputStream(buffer);
			ObjectInputStream OIS = new ObjectInputStream(BAIS);
			o = OIS.readObject();
		}catch(Exception e){
			System.out.println("Error in convertToObject");
		}
		return o;
	}	

	/**
	 * Metodo che serializza un oggetto
	 * @param query Oggetto da serializzare
	 * @return Serializzazione dell'oggetto
	 */	
	public String convertToString(Object query){
		String s = null;
		try{
			ByteArrayOutputStream BAOS = new ByteArrayOutputStream();
			ObjectOutputStream OOS = new ObjectOutputStream(BAOS);
			OOS.writeObject(query);
			s = new String(BAOS.toString());
		}catch(Exception e){
			System.out.println("Error in convertToString");
		}
		return s;
	}		
	
}