package DBAgent;

import java.util.Vector;
import alice.logictuple.LogicTuple;
import alice.tucson.api.*;

/**
 * Interfaccia dell'agente queryOpt
 * @author luca vanzolini
 */
public interface IQueryOptAgent {
	
	/**
	 * Metodo che permette di notificare all'agente queryOpt l'ingresso nel sistema di un 
	 * nuovo terminale
	 * @param tcidCoda centro tuple "coda"
	 * @param tcidQuery centro tuple "query"
	 * @param name identificativo del terminale
	 */
	public void addTerminal(TupleCentreId tcidCoda, TupleCentreId tcidQuery, String name);
	
	/**
	 * Metodo che permette di notificare all'agente queryOpt l'uscita dal sistema di un 
	 * terminale
	 * @param name identificativo del terminale che si scollega dal sistema
	 */	
	public void removeTerminal(String name);
	
	/**
	 * Metodo che permette la notifica di una nuova query su una qualsiasi coda
	 * @param query Query
	 * @param name nome del terminale da cui  stata l'anciata la query
	 */
	public void newQery(LogicTuple query, String name);
	
	/**
	 * 
	 * @param querys
	 */
	public void SetNewOptQuery(LogicTuple querys);
	
	/**
	 * 
	 * @return
	 */
	public Vector GetSuspendQuery();
	
	/**
	 * 
	 * @return
	 */
	public LogicTuple GetNewOptQuery();
	
	/**
	 * 
	 * @return
	 */
	public Vector GetTCQueryVector();
	
	/**
	 * 
	 * @param Tid
	 * @return
	 */
	public String GetHostName(int Tid);
	
	/**
	 * 
	 * @param Qid
	 */
	public void removeQuery(int Qid);
	
	/**
	 * 
	 * @param Qid
	 */
	public void UpdateNewOptQuery(int Qid);
	
	/**
	 * 
	 */
	public Vector GetNameHostVector();
	
}
