package DBAgent;

import alice.logictuple.*;
import alice.tucson.api.*;
import java.util.Vector;
import java.io.*;

/**
 * Agente che si occupa di mettere in esecuzione le query
 */
public class QueryExecute extends Agent {
	
	/**
	 * QueryOptAgent del terminale corrente
	 */
	IQueryOptAgent QAgent;
	
	/**
	 * Centro tuple peer la sincronizzazione locale
	 */
	TupleCentreId LocalSinc;
	
	/**
	 * Centro tuple peer la sincronizzazione locale
	 */
	TupleCentreId Sinc;
	
	int Tid;
	
	/**
	 * Costruttore
	 * @param A QueryOptAgent del terminale corrente
	 */	
	public QueryExecute(AgentId name, int T, IQueryOptAgent A, TupleCentreId LSinc, TupleCentreId Sinc) throws TucsonException{
		super(name);
		QAgent = A;
		LocalSinc = LSinc;
		this.Sinc = Sinc;
		Tid = T;
	}
	
	/**
	 * Corpo del thread
	 */
	public void body(){
		try{
			while(true){
				LogicTuple req = new LogicTuple("Ready");
				LogicTuple reqE = in(LocalSinc,req);
				LogicTuple req_1 = new LogicTuple("Ready");
				LogicTuple reqE_1 = in(Sinc,req_1);
				Vector Result = new Vector();
				
				LogicTuple sem = new LogicTuple("QuerySinc", new Var("S"));
				LogicTuple semaforo = in(LocalSinc,sem);
				TupleArgument S = semaforo.getArg(0);
				if(S.intValue() == 0){
					
					System.out.println("Query eseguita");
					
					Vector hosts = QAgent.GetNameHostVector();
					LogicTuple sem_s = new LogicTuple("QuerySinc", new Value(1));
					for(int i=0; i<hosts.size(); i++){
						String LT_Host = "localSinc @ " + ((String)(hosts.elementAt(i)));
						TupleCentreId TC = new TupleCentreId(LT_Host);
						inp(TC,sem);
						out(TC,sem_s);
					}					
					in(LocalSinc,sem_s);
					
					LogicTuple query = QAgent.GetNewOptQuery();
					TupleArgument queryS = query.getArg(0);
					String queryString = queryS.toString();
				
					TupleArgument Uid_TA = query.getArg(1);
					TupleArgument Tid_TA = query.getArg(2);
					TupleArgument Qid_TA = query.getArg(3);
					
					QAgent.removeQuery(Qid_TA.intValue());
					
					LogicTuple RQ = new LogicTuple("removeQuery", new Value(Qid_TA.intValue()), new Value(this.Tid));
					out(Sinc,RQ);	
					
					Vector TCQuery = QAgent.GetTCQueryVector();
					for(int i=0; i<TCQuery.size(); i++){
						out(((TupleCentreId)TCQuery.elementAt(i)),new LogicTuple("query",new Value(queryString)));
					}
					
					for(int i=0; i<TCQuery.size(); i++){
						LogicTuple resp = in(((TupleCentreId)TCQuery.elementAt(i)),new LogicTuple("result",new Var("Res")));
						TupleArgument Res = resp.getArg(0);
						String ResS = Res.toString();
						String ResS_E = ResS.substring(1,ResS.length()-1);
						Result.addElement(convertToObject(ResS_E));
					}				
				
					String resultS = convertToString(Result);
					LogicTuple Ris = new LogicTuple("result", new Value(resultS), Uid_TA, Tid_TA, Qid_TA);
					String hostName = QAgent.GetHostName(Tid_TA.intValue());
					TupleCentreId Coda = new TupleCentreId("coda @ " + hostName);
					out(Coda,Ris);
					
				}
				
				LogicTuple A_sem = new LogicTuple("QuerySinc", new Value(0));
				out(LocalSinc,A_sem);
				out(Sinc,req_1);	
												
			}
		}catch(Exception e){}		
	}
	
	/**
	 * Metodo che serializza un oggetto
	 * @param query Oggetto da serializzare
	 * @return Serializzazione dell'oggetto
	 */	
	public String convertToString(Object query){
		String s = null;
		try{
			ByteArrayOutputStream BAOS = new ByteArrayOutputStream();
			ObjectOutputStream OOS = new ObjectOutputStream(BAOS);
			OOS.writeObject(query);
			s = new String(BAOS.toString());
		}catch(Exception e){
			System.out.println("Error in convertToString");
		}
		return s;
	}	
	
	/**
	 * Metodo che crea un oggetto dalla sua serializzazione
	 * @param queryS Oggetto serializzato
	 * @return Oggetto
	 */
	public Object convertToObject(String queryS){
		Object o = null;
		try{		
			byte[] buffer = queryS.getBytes();
			ByteArrayInputStream BAIS = new ByteArrayInputStream(buffer);
			ObjectInputStream OIS = new ObjectInputStream(BAIS);
			o = OIS.readObject();
		}catch(Exception e){
			System.out.println("Error in convertToObject");
		}
		return o;
	}	
	
}
