package DBAgent;

import alice.tucson.api.*;
import alice.logictuple.*;

/**
 * Thread che sta in ascolto su unl centro tuple "coda"
 * @author lucavan
 */
public class QueryListener extends Thread{
	
	/**
	 * identificativo del terminale
	 */
	int Tid;	
	
	/**
	 * identificatore del centro tuple "coda"
	 */
	TupleCentreId IdCoda;

	/**
	 * riferimento del QueryOptAgent
	 */
	QueryOptAgent Ottimizzatore;
	
	/**
	 * Contesto di lavoro tucson
	 */	
	TucsonContext ctx;
	
	/**
	 * identificativo del terminale della coda
	 */
	String name;
	
	/**
	 * Cosruttore
	 * @param O QueryOptAgent
	 * @param coda identificatore del centro tuple "coda"
	 */
	public QueryListener(int Tid, QueryOptAgent O, TupleCentreId coda, String n){
		super();
		this.Tid = Tid;
		name = n;
		IdCoda = coda;
		Ottimizzatore = O;
		try{
			ctx = Tucson.enterDefaultContext();
		}catch(Exception e){}
		this.start();
	}
	
	/**
	 * corpo del thread
	 */
	public void run(){
		try{
			while(true){
				LogicTuple req = new LogicTuple("query_e", new Var("QueryS"), new Var("UidQ"), new Var("TidQ"), new Var("QidQ"), new Var("From"), new Var("Where"), new Value(Tid));
				LogicTuple reqE = ctx.in(IdCoda,req);	
				Ottimizzatore.newQery(reqE,name);
			}
		}catch(Exception e){
			System.out.println("");
		}		
	}
	
}
