package DBAgent;

import alice.tucson.api.*;

import java.util.Vector;
import alice.logictuple.*;

/**
 * Agente che si occupa di decidere quale strategia applicare in base alle 
 * query pendenti
 */
public class QueryOpt extends Agent {

	/**
	 * QueryOptAgent del terminale corrente
	 */
	IQueryOptAgent QAgent;	
	
	/**
	 * Centro tuple peer la sincronizzazione locale
	 */
	TupleCentreId LocalSinc;
	
	/**
	 * Costruttore
	 * @param A QueryOptAgent del terminale corrente
	 */
	public QueryOpt(AgentId name, IQueryOptAgent A, TupleCentreId Sinc) throws TucsonException{
		super(name);
		QAgent = A;
		LocalSinc = Sinc;
	}	
	
	/**
	 * Corpo del thread
	 */
	public void body(){
		try{
			while(true){
				LogicTuple req = new LogicTuple("newQuery");
				LogicTuple reqE = in(LocalSinc,req);
				OptCicle();							
			}
		}catch(Exception e){}		
	}
	
	/**
	 * Funzione che scansiona il vettore delle query in attesa allo scopo di elaborare
	 * una strategia di esecuzione ottima delle stesse
	 */
	public void OptCicle(){
		try{
			LogicTuple req = new LogicTuple("Ready");
			LogicTuple reqE = inp(LocalSinc,req);
			
			Vector querys = QAgent.GetSuspendQuery();
			if(querys.size() != 0){
				LogicTuple query = (LogicTuple)querys.elementAt(0);
				QAgent.SetNewOptQuery(query);			
				out(LocalSinc,req);
				
/*				LogicTuple sem = new LogicTuple("QuerySinc", new Var("S"));
				LogicTuple semaforo = in(LocalSinc,sem);		
				LogicTuple S = new LogicTuple("QuerySinc", new Value(0));
				out(LocalSinc,S);*/
			}
		}catch(Exception e){}	
	}
	
}
