package DBAgent;

import alice.logictuple.*;
import alice.tucson.api.*;
import SQLIstructionSet.*;
import java.io.*;

/**
 * agente che rappresenta un Utente
 * @author luca vanzolini
 */
public class Utente implements IUtente {
	
	/**
	 * Identificatore univoco dell'utente
	 */
	int Uid;
	
	/**
	 * Identificatore univoco del terminale
	 */
	int Tid;
	
	/**
	 * Identificatore del centro tuple
	 */
	TupleCentreId tc;
	
	/**
	 * Contesto di lavoro tucson
	 */	
	TucsonContext ctx;
	
	GInterface I;
	
	Utente_R UR;
	
	Utente_E UE;
	
	/**
	 * Costruttore
	 * @param id Identificatore univoco dell'utente
	 * @param tid Identificatore univoco del terminale
	 * @param tcId identificatore del centro tuple (coda)
	 */
	public Utente (int id, int tid, TupleCentreId tcId) throws TucsonException{
		Uid = id;
		this.Tid = tid;
		tc = tcId;
		try{
			ctx = Tucson.enterDefaultContext();
		}catch(Exception e){}
		AgentId Aid = new AgentId("alice");
		UR = new Utente_R(Aid,Uid,Tid,tc);
		UR.spawn();
		Aid = new AgentId("alice");
		UE = new Utente_E(Aid,Uid,Tid,tc);
		UE.spawn();
	}
	
	/**
	 * metodo che permette di inserire una nuova query nel sistema
	 * @param query Query da risolvere
	 */
	public void newQuery(SQLIstruction query, int Qid){
		String queryS = convertToString(query);
		try{
			LogicTuple req = new LogicTuple("query", new Value(queryS), new Value(Uid), new Value(Tid), new Value(Qid));
			ctx.out(tc,req);
		}catch(Exception e){
			System.out.println("Error: send message fail");
		}		
	}

	/**
	 * Metodo che serializza un oggetto
	 * @param query Oggetto da serializzare
	 * @return Serializzazione dell'oggetto
	 */	
	public String convertToString(Object query){
		String s = null;
		try{
			ByteArrayOutputStream BAOS = new ByteArrayOutputStream();
			ObjectOutputStream OOS = new ObjectOutputStream(BAOS);
			OOS.writeObject(query);
			s = new String(BAOS.toString());
		}catch(Exception e){}
		return s;
	}	
	
	public void register(GInterface I){
		this.I = I;
		UR.register(I);
		UE.register(I);
	}

}