package DBAgent;

import alice.logictuple.*;
import alice.tucson.api.*;
import java.io.*;
import java.util.Vector;

/**
 * agente che rappresenta un Utente
 * @author luca vanzolini
 */
public class Utente_R extends Agent{
	
	/**
	 * Identificatore univoco dell'utente
	 */
	int Uid;
	
	/**
	 * Identificatore univoco del terminale
	 */
	int Tid;
	
	/**
	 * Identificatore del centro tuple
	 */
	TupleCentreId tc;
	
	GInterface I;
	
	/**
	 * Costruttore
	 * @param id Identificatore univoco dell'utente
	 * @param tid Identificatore univoco del terminale
	 * @param tcId identificatore del centro tuple (coda)
	 */
	public Utente_R (AgentId name, int id, int tid, TupleCentreId tcId) throws TucsonException{
		super(name);
		Uid = id;
		this.Tid = tid;
		tc = tcId;
	}
	
	/**
	 * Corpo del thread
	 */
	public void body(){
		try{
			while(true){
				LogicTuple req = new LogicTuple("result", new Var("QueryResult"), new Value(Uid), new Value(Tid), new Var("Qid"));
				LogicTuple resp = in(tc,req);	
				TupleArgument Q = resp.getArg(0);
				TupleArgument QidT = resp.getArg(1);
				String QS = Q.toString();
				QS = QS.substring(1,QS.length()-1);
				SendResponse(convertToObject(QS),QidT.intValue());	
			}
		}catch(Exception e){}
	}
	
	/**
	 * Metodo che crea un oggetto dalla sua serializzazione
	 * @param queryS Oggetto serializzato
	 * @return Oggetto
	 */
	public Object convertToObject(String queryS){
		Object o = null;
		try{	
			ByteArrayInputStream BAIS = new ByteArrayInputStream(queryS.getBytes());
			ObjectInputStream OIS = new ObjectInputStream(BAIS);
			o = OIS.readObject();
		}catch(Exception e){}
		return o;
	}	
	
	/**
	 * Metodo che spedisce l'oggetto che rappresenta la risposta ad una query
	 * @param obj Oggetto che rappresenta la risposta ad una query
	 * @param q id della query
	 */
	private void SendResponse(Object obj, int q){
		System.out.println("Risposta ricevuta");
		Vector Ris = ((Vector)obj);
		I.writeResult(Ris);
	}
	
	public void register(GInterface I){
		this.I = I;
	}

}
